using System.Net.Http.Headers;

namespace API_Tests_Console;
using System.Text;
using System.Text.Json;
using Entities;
using Model;
public class Tests_Console_Connect_API
{
    // See https://aka.ms/new-console-template for more information

    static string tokenAPI =
        "CfDJ8BzHcEhs6r9BlTUBqjgLGaNf6WAMKOugl8uuuypKPb1asjgUip-391in3rJXoNOFAM9pEtczqk3OQrTw0-GpQWq5_IWjXwoEAnoWMXVdKnyNXutqU07I_py4cVgGEkx3WVirYMAIY2LtXTMBkfqcirhauvr_GwWpnumMWthDz5cIFl-EBEVOHf5bL7DRk0EZrG97HT8gpk9HQ__YxD2pQ8g7p0BFMs5FGaZeLQEC0bD07ttOtnxwaNlo4R0e6VVInAdRuXipNDEAESd8AIUtUwbv1x-KCMqdJ8_6dKSsip2iOerCBBDI8xgFN99GETT_tGQI05yNCLsxNpzEzH3H-EC8C7KUIw0h72CdeGC8ZSnnbxzNIpMMgDP9vdrlVxcYAqQwJGNOj5i_c2bMtoT6AAWaALLkhueJhX6F7_darIr6_lervAdQS2RBhIrhpPnlwef6S3xoSLBYq5PNYAg_17EECnLISWwkX_kZCfSHtxMsiAjr_rhsXkE5Ku_J5TQooATrSZk_fD5p3dUS87ijl9MrR1M3pRuI30oe3o-tiSnvoY6GQUcw3ES3CpoPWA_Z_3gtkPTcmdpJC8Hu_Vpx16U8y25R5iIMHLV_cz_rx79yRjikq9L_wSCkaC4cCo_sWQ1uesQjkCkX4Jn2Q-5Sxm4Piq7Yj5Fu3FvDPqXUoG4xGxhV8wnMMiM3kpmp69nrpA";

    static readonly HttpClient client = new HttpClient();

    public static async Task Main2(string[] args)
    {
        await TestUser();
        await TestFormulaire();
        await TestArticle();
    }

    private static async Task TestFormulaire()
    {
        await TestFormulaireGetAll();
        await TestFormulaireGetId();
        //await TestFormulaireCreate();
        //await TestFormulaireDelete();
        //await TestFormulaireUpdate();
    }

    private static async Task TestUser()
    {
        await TestUserGetAll();
        await TestUserGetId();
        //await TestUserCreate();
        //await TestUserDelete();
        //await TestUserUpdate();
        await TestGetAllArticleUser();
        await TestGetArticleByUser();
        //await TestCreateArticleUser();
        //await TestDeleteArticleUser();
        //await TestUpdateArticleUser();
    }


    static async Task TestArticle()
    {
        await TestArticleGetId();
        //await TestArticleCreate();
        await TestArticleGetAll();
        //await TestArticleDelete();
        //await TestArticleUpdate();
    }
    
    static async Task TestArticleGetAll()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.GetAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/articles");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestArticleGetId()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.GetAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/article/1");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestArticleCreate()
    {
        try
        {
            var article = new Article()
            {
                Title = "Test",
                Description = "Test",
                Author = "Test",
                DatePublished = "Test",
                LectureTime = 0
            };
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var json = JsonSerializer.Serialize(article);
            var data = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PostAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/article", data);
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestArticleDelete()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.DeleteAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/article/1");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestArticleUpdate()
    {
        try
        {
            var article = new Article()
            {
                Title = "Louis",
                Description = "Je",
                Author = "T'",
                DatePublished = "aime",
                LectureTime = 0
            };
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var json = JsonSerializer.Serialize(article);
            var data = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PutAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/article/1", data);
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestFormulaireGetAll()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.GetAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/formulaires");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestFormulaireGetId()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.GetAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/formulaire/1");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestFormulaireCreate()
    {
        try
        {
            var formulaire = new Formulaire()
            {
                Theme = "Test",
                Date = "Test",
                Lien = "Test",
                UserPseudo = "Sha"
            };
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var json = JsonSerializer.Serialize(formulaire);
            var data = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PostAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/formulaire", data);
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestFormulaireDelete()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.DeleteAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/formulaire/5");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestFormulaireUpdate()
    {
        try
        {
            var formulaire = new Formulaire()
            {
                Theme = "J'",
                Date = "aime",
                Lien = "Les",
                UserPseudo = "Sha"
            };
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var json = JsonSerializer.Serialize(formulaire);
            var data = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PutAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/", data);
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestUserGetAll()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.GetAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/users");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestUserGetId()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.GetAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/user/Sha");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestUserCreate()
    {
        try
        {
            var user = new User()
            {
                Pseudo = "J",
                Nom = "'",
                Prenom = "aime",
                Mail = "les",
                Mdp = "pieds",
                Role = "Admin"
            };
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var json = JsonSerializer.Serialize(user);
            var data = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PostAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/user", data);
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestUserDelete()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.DeleteAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/user/Sha");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestUserUpdate()
    {
        try
        {
            var user = new User()
            {
                Pseudo = "Sha",
                Nom = "J'",
                Prenom = "aime",
                Mail = "les",
                Mdp = "pieds",
                Role = "Admin"
            };
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var json = JsonSerializer.Serialize(user);
            var data = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PutAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/user/Sha", data);
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestGetAllArticleUser()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.GetAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/article/users");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestGetArticleByUser()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.GetAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/user/Sha/articles");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestCreateArticleUser()
    {
        try
        {
            var articleUser = new ArticleUserEntity()
            {
                ArticleEntityId = 1,
                UserEntityPseudo = "Sha"
            };
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var json = JsonSerializer.Serialize(articleUser);
            var data = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PostAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/user/article", data);
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }

    static async Task TestDeleteArticleUser()
    {
        try
        {
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            var response = await client.DeleteAsync("https://codefirst.iut.uca.fr/containers/Verax-verax-api/user/Sha/3");
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
    static async Task TestUpdateArticleUser()
    {
        try
        {
            var articleUser = new ArticleUserEntity()
            {
                ArticleEntityId = 2,
                UserEntityPseudo = "Sha"
            };
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", tokenAPI);
            long oldId = 3;
            var json = JsonSerializer.Serialize(articleUser);
            var data = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PutAsync($"https://codefirst.iut.uca.fr/containers/Verax-verax-api/user/Sha/{oldId}", data);
            response.EnsureSuccessStatusCode();
            var responseBody = await response.Content.ReadAsStringAsync();
            Console.WriteLine(responseBody);
        }
        catch (Exception e)
        {
            Console.WriteLine(e.Message);
        }
    }
    
}